CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
  #octets=4
CompilerElse
  #octets=8
CompilerEndIf
Structure mem
  Dat.i
EndStructure


ProcedureDLL Heap_New()
  *mem.mem=AllocateMemory(#octets)
  If *mem=0:Debug "Heap Final\newheap() n'a pu allouer la mmoire":EndIf
  *mem\Dat=0;nombre d'lments dans le tas: 0
  ProcedureReturn *mem 
EndProcedure

ProcedureDLL Heap_Clear(heap.i)
  *mem.mem=ReAllocateMemory(heap,#octets)
  If *mem=0:Debug "clearheap n'a pu rduire la mmoire":EndIf
  *mem\Dat=0;nombre d'éléments dans le tas: 0
  ProcedureReturn *mem
EndProcedure

ProcedureDLL Heap_Free(*mem)
  FreeMemory(*mem)
EndProcedure

ProcedureDLL Heap_AddElement(*memo,*key)
  EnableASM
  
  MOV ebp, dword [p.p_memo]
  MOV ebx, dword [ebp] ;charge le nombre d'element
  INC ebx              ;nb element+1
  MOV dword [ebp],ebx  ;nb element+1
  LEA eax,[ebx*4+4] ;calcul le nombre d'octets  assigner
  PUSH ebx
  PUSH eax  ;nombre d'octets  assigner en mmoire
  PUSH ebp ;adresse de dbut
  CALL  _PB_ReAllocateMemory@8 ;nouvelle adresse dans eax
  POP ebx
  CMP eax,0
  JE _fin ;erreur renvoie 0
  MOV dword [p.p_memo],eax
  
  
  LEA ecx, [eax+ebx*4] ;vrifier si ebx est toujours  la mme valeur
  
  MOV edx, dword [p.p_key]
  MOV dword [ecx],edx ;mets l'adresse cl en fin de tas
  
  ;eax = memoire de base
  ;ebx = numero element courant
  !boucle0:
  LEA edi, [eax+ebx*4] ;edi= actuel
  SHR ebx,1 ;>>1
  LEA ebp, [eax+ebx*4] ;ebp = pre  
  CMP ebx,0 ;si courant <1
  JZ _fin2
  MOV ecx, dword [ebp]
  PUSH ecx
  MOV ecx, dword [ecx];PeekI(PeekI(*pere))
  MOV edx, dword [edi]
  PUSH edx
  CMP ecx,dword [edx] ;PeekI(PeekI(*actuel))
  JB _fin1            ;sort si infrieur strictement
  POP dword [ebp]
  POP dword [edi]
  JMP boucle0
  
  ;courant.i=nb
  ;*mem+courant*#octets
  ;*mem\Dat=*key
  ;;PokeI(*mem+courant*#octets,*key) ;met l'adresse de la valeur en fin de tas
;   Repeat
;     *actuel.mem=*mem+courant*#octets
;     courant=courant>>1
;     *pere.mem=*mem+courant*#octets ;i/2
;     If courant<1 Or PeekI(PeekI(*pere))<PeekI(PeekI(*actuel)):Break:EndIf
;     swap1.i=*pere\Dat
;     swap2.i=*actuel\Dat
;     *pere\Dat=swap2    ;PokeI(*pere,swap2)
;     *actuel\Dat=swap1 ;PokeI(*actuel,swap1) 
;   ForEver
  !_fin:
  ProcedureReturn
  !_fin1:
  POP ecx
  POP ecx
  ProcedureReturn *memo
  !_fin2:
  ProcedureReturn *memo
DisableASM  
EndProcedure

ProcedureDLL Heap_Heapify(*mem,*mem1)
  nb.i=PeekI(*mem)
  
  For i=1 To nb
    If PeekI(*mem+#octets*i)=*mem1:Break:EndIf
  Next i
  
  Repeat
    L.i=i<<1 ;gauche
    R.i=L+1 ;droit
    If L<=nb And PeekI(PeekI(*mem+L*#octets))<PeekI(PeekI(*mem+i*#octets))
      Min=L
    Else
      Min=i
    EndIf
    If R<=nb And PeekI(PeekI(*mem+R*#octets))<PeekI(PeekI(*mem+Min*#octets))
      Min=R
    EndIf
    If Min=i:Break:EndIf
    swap1.i=PeekI(*mem+i*#octets)
    swap2.i=PeekI(*mem+Min*#octets)
    PokeI(*mem+i*#octets,swap2)
    PokeI(*mem+Min*#octets,swap1)    
    i=Min
  ForEver
  
;   EnableASM
;   MOV ebp, dword [p.p_memo]
;   MOV ecx, [ebp] ;ecx= nb
;   MOV edx,dword [p.p_mem1]
;   MOV ebx,1
;   ;*mem.mem=*memo
;   ;nb.i=*mem\Dat
;   !_boucle20:
;   LEA eax,[ebp+ebx*4]
;   CMP dword [eax],edx
;   JE _sortir1
;   INC ebx
;   CMP ebx,ecx
;   JNE _boucle20
;   !_sortir1:
;   MOV eax, ecx
;   
;   
;   ;L =ecx
;   ;R = edx
;   ;mem0 = ebp
;   ;Min = esi
;   ;nb = eax
; 
;   ;MOV ebx,1 ;i = ebx 
;   !_boucle10:
;                              PUSH eax ;sauve nb
;   LEA ecx, [ebx*2] ;L= i<<1
;   LEA edx, [ecx+1] ;R= L+1
;   CMP ecx,eax ;L<=nb
;   JA _Su10     ;saute si suprieur
;   
;   LEA edi,[ebp+ecx*4] ;*mem0+L*#octets
;   MOV edi,dword [edi];PeekI(*mem0+L*#octets)
;   MOV edi,[edi];PeekI(PeekI(*mem0+L*#octets))
;   LEA eax,[ebp+ebx*4] ;*mem0+i*#octets
;   MOV eax,dword [eax];PeekI(*mem0+i*#octets)
;   MOV eax,dword [eax];PeekI(PeekI(*mem0+i*#octets))  
;   CMP edi,eax
;   JAE _Su10     ;saute si suprieur ou egal
;   
;   MOV esi,ecx;Min=L
;   JMP _su30
;   
;   !_Su10:
;   MOV esi,ebx ;Min=i
; 
;   !_su30:
;                             POP eax ;rcupre nb
;                             PUSH eax ;sauve nb
;   CMP edx,eax ;R<=nb
;   JA _Su20     ;saute si suprieur
;   
;   LEA edi,[ebp+edx*4] ;*mem0+R*#octets
;   MOV edi,[edi];PeekI(*mem0+R*#octets)
;   MOV edi,[edi];PeekI(PeekI(*mem0+R*#octets))
;   LEA eax,[ebp+esi*4] ;*mem0+i*#octets
;   MOV eax,[eax];PeekI(*mem0+i*#octets)
;   MOV eax,[eax];PeekI(PeekI(*mem0+i*#octets))  
;   CMP edi,eax
;   JAE _Su20;saute si superieur ou egale
;   
;   MOV esi,edx  ;Min=R
;   
;   !_Su20:
;   POP eax ;rcupre nb
; 
;   CMP esi,ebx ;If Min=i:Break:EndIf
;   JE _fin110
;   
;   PUSH eax ;sauve eax
;   
;   LEA eax,[ebp+ebx*4] ;*mem0+i*#octets
;   PUSH dword [eax] ;PeekI(*mem0+i*#octets)
;   LEA edi,[ebp+esi*4] ;*mem0+Min*#octets
;   PUSH dword [edi];PeekI(*mem0+Min*#octets,swap1)  
;   LEA eax,[ebp+ebx*4]
;   POP dword [eax];     PokeI(*mem0+i*#octets,swap2)
;   POP dword [edi];     PokeI(*mem0+Min*#octets,swap1)  
;   
;   POP eax ;rcupre eax
;   MOV ebx,esi;     i=Min 
;   JMP _boucle10 ;  ForEver
;     
; 
; 
;   !_fin110:
;   ProcedureReturn *Minimum
;   !_fin100:
;   ProcedureReturn ;retourne 0
;   
;   DisableASM

EndProcedure

ProcedureDLL Heap_GetMin(*mem0) ;retourne zero si vide, sinon l'adresse de l'element minimum.
  *minimum=0
  EnableASM
  MOV ebp, dword [p.p_mem0] ;ebp=*mem0
  MOV eax, dword [ebp] ;Eax=nb
  CMP Eax,0
  JZ _fin10 ;tas vide car nb element=0
  
  MOV ebx,dword [ebp+4] ;ebx= adresse minimum  renvoyer
  MOV dword [p.p_minimum],ebx ;adresse sauvegarde
  LEA ecx, [ebp+eax*4]
  PUSH dword [ecx]
  POP dword [ebp+4]
  DEC dword [ebp] ;PokeI(*mem0,nb-1)
  DEC eax ;nb-1 encore
 
  ;L =ecx
  ;R = edx
  ;mem0 = ebp
  ;Min = esi
  ;nb = eax
  MOV ebx,1 ;i = ebx 
  !_boucle1:
  PUSH eax ;sauve nb
  LEA ecx, [ebx*2] ;L= i<<1
  LEA edx, [ecx+1] ;R= L+1
  CMP ecx,eax ;L<=nb
  JA _Su1     ;saute si suprieur
  
  LEA edi,[ebp+ecx*4] ;*mem0+L*#octets
  MOV edi,dword [edi];PeekI(*mem0+L*#octets)
  MOV edi,[edi];PeekI(PeekI(*mem0+L*#octets))
  LEA eax,[ebp+ebx*4] ;*mem0+i*#octets
  MOV eax,dword [eax];PeekI(*mem0+i*#octets)
  MOV eax,dword [eax];PeekI(PeekI(*mem0+i*#octets))  
  CMP edi,eax
  JAE _Su1      ;saute si suprieur ou egal
  
  MOV esi,ecx;Min=L
  JMP _su3
  
  !_Su1:
  MOV esi,ebx ;Min=i

  !_su3:
                            POP eax ;rcupre nb
                            PUSH eax ;sauve nb
  CMP edx,eax ;R<=nb
  JA _Su2     ;saute si suprieur
  
  LEA edi,[ebp+edx*4] ;*mem0+R*#octets
  MOV edi,[edi];PeekI(*mem0+R*#octets)
  MOV edi,[edi];PeekI(PeekI(*mem0+R*#octets))
  LEA eax,[ebp+esi*4] ;*mem0+i*#octets
  MOV eax,[eax];PeekI(*mem0+i*#octets)
  MOV eax,[eax];PeekI(PeekI(*mem0+i*#octets))  
  CMP edi,eax
  JAE _Su2;saute si superieur ou egale
  
  MOV esi,edx  ;Min=R
  
  !_Su2:
  POP eax ;rcupre nb

  CMP esi,ebx ;If Min=i:Break:EndIf
  JE _fin11
  
  PUSH eax ;sauve eax
  
  LEA eax,[ebp+ebx*4] ;*mem0+i*#octets
  PUSH dword [eax] ;PeekI(*mem0+i*#octets)
  LEA edi,[ebp+esi*4] ;*mem0+Min*#octets
  PUSH dword [edi];PeekI(*mem0+Min*#octets,swap1)  
  LEA eax,[ebp+ebx*4]
  POP dword [eax];     PokeI(*mem0+i*#octets,swap2)
  POP dword [edi];     PokeI(*mem0+Min*#octets,swap1)  
  
  POP eax ;rcupre eax
  MOV ebx,esi;     i=Min 
  JMP _boucle1 ;  ForEver
    


  !_fin11:
  ProcedureReturn *Minimum
  !_fin10:
  ProcedureReturn ;retourne 0
  
  DisableASM  
EndProcedure

ProcedureDLL Heap_Size(*mem)
  ProcedureReturn PeekI(*mem)
EndProcedure

; *tas=newheap()
; Dim a.i(1000)
; For i=1 To 1000
;   a(i)=Random(1000)
; Next i
; For i= 1 To 999
;   *tas=AddHeapElement(*tas,@a(i))
; Next i
; Debug PeekI(GetHeapMin(*tas))


; ; Exemples
; NewList TEST.i()
; nbelement.i=10000
; *tas1=NewHeap()
; 
; timer1.i=ElapsedMilliseconds()
; For i=1 To nbelement
;   AddElement(test())
;   test()=Random(nbelement)  
;   *tas1=AddHeapElement(*tas1,@test())
;   If *tas1=0:Debug "erreur":EndIf
; Next i
; ;Debug *tas1
; ;   For i=1 To nbelement
; ;     Debug Str(*tas1+i*4)+" "+Str(PeekI(*tas1+i*4))+" "+Str(PeekI(PeekI(*tas1+i*4)))
; ; Next i
; 
; 
; Repeat
; ;   Debug PeekI(*tas1)
; ;   For i=1 To nbelement
; ;     Debug Str(*tas1+i*4)+" "+Str(PeekI(*tas1+i*4))+" "+Str(PeekI(PeekI(*tas1+i*4)))
; ; Next i
; ;Debug "min extrait, tas reconstruit"
; *adresseMin=GetHeapMin(*tas1);,@test(),@test())
;   If *adresseMin=0:Debug "Tas vide":Break:EndIf
; Debug "mini "+Str(PeekI(*adresseMin)) 
; ForEver
; 
; MessageRequester("Vitesse",Str(ElapsedMilliseconds()-timer1)+"ms")
; ; ;100 000 elements
; ; ;#74-75ms (min 72)
; IDE Options = PureBasic 5.44 LTS (Windows - x86)
; ExecutableFormat = Shared dll
; CursorPosition = 10
; Folding = P9
; EnableAsm
; EnableUnicode
; Executable = librairie tas.dll
; CPU = 1
; ꪫꫮ鮺ꯪ랪ꫫꦿ뫮몺믫ꊮ껪꺛ꫮꪾ꿪
; 骪뿫ꦺꋪꪻꛮꮪ믪몪껫ꪯ뫮ꪪ믪ꪮꫪ
; 骪뿫ꢺꋪꪋꛮ뮪诪몪껨ꪯ뫮ꪺ믪ꪮꫪ
; 骪뿫ꦺ껪ꪋꛮꮪ믪몪껫ꪯ뫮ꪺ믪꺮ꫪ
; ꫪ꺫ꫮ몮꿪꺺뛫ꦫꫮ뾪꯫ꦪꫫꢯ뫮ꚪ